/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Mode de jeu : temps d'un tour, configuration des armes, nombre de ver
 * maximum par quipe, etc.
 *****************************************************************************/

#ifndef MODE_JEU_H
#define MODE_JEU_H
//-----------------------------------------------------------------------------
#include "../include/base.h"
#include "../tool/xml_document.h"
#include <string>
//-----------------------------------------------------------------------------
namespace Wormux {
//-----------------------------------------------------------------------------

class ConfigVer
{
public:
  uint energie_init;
  uint energie_max;
  uint masse;
  uint force_saut;
  int angle_saut;
  uint force_super_saut;
  int angle_super_saut;
};

//-----------------------------------------------------------------------------

class ModeJeu
{
public:
  // Equipe et vers
  uint nbr_ver_max;
  uint nbr_equipe_max;

  // Temps d'un tour
  uint temps_tour;
  uint temps_fin_tour;

  // Armes
  ConfigVer ver;

  enum {
    ALWAYS,
    BEFORE_FIRST_ACTION,
    NEVER
  } allow_character_selection;
    
public:
  ModeJeu();
  bool Charge (const std::string &nomfich);

  bool AllowCharacterSelection() const;

protected:
  bool ChargeXml (xmlpp::Element *xml);
};

//-----------------------------------------------------------------------------
extern ModeJeu mode_jeu;
//-----------------------------------------------------------------------------
} // namespace Wormux
#endif
