/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Refresh des animations : plusieurs images dfilant selon un chronomtre.
 * Il est possible de faire une rotation horizontale de l'image.
 *****************************************************************************/

#ifndef ANIMATION_H
#define ANIMATION_H
//-----------------------------------------------------------------------------
#include "../include/base.h"
#include "sprite.h"
//-----------------------------------------------------------------------------

typedef enum
{
  animBOUCLE,
  animUNE_BOUCLE,
  animARRET
} animation_t;

//-----------------------------------------------------------------------------

class Animation : public Sprite
{
private:
  uint pause, vitesse;
  animation_t type;
  bool finie;

public:
  // Initialise les donnes
  void Init (CL_Sprite *surface,	     
	     bool autorise_rotation=false,
	     animation_t type=animARRET,
	     uint vitesse=0); // O n'est valide que pour type=animARRET

  // Change le type d'une animation
  void ChangeType (animation_t type,
		   uint vitesse=0);  // O n'est valide que pour type=animARRET

  // Mise au zro (au dbut du jeu)
  void Reset();

  // Arrte l'animation
  void Stop();

  // Refresh d'un tour
  void Refresh();

  // L'animation est finie ?
  bool EstFinie() const;

  void Draw(int x, int y) const;

  // Passe  la frame suivante
  virtual void FrameSuivante();
};

//-----------------------------------------------------------------------------
#endif
