/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Police de caractre.
 *****************************************************************************/

#include "font.h"
//-----------------------------------------------------------------------------
#include "../tool/string_tools.h"
//-----------------------------------------------------------------------------

Police::Police()
{ m_police = NULL; }

//-----------------------------------------------------------------------------

void Police::Charge (const std::string& resource_id, 
		     CL_ResourceManager* manager)
{
  assert (m_police == NULL);
  m_police = new CL_Font(resource_id, manager);
}
//-----------------------------------------------------------------------------

void Police::EcritGauche (int x, int y, const std::string &txt)
{ 
  Acces().set_alignment (origin_top_left);
  Acces().draw(x,y,txt); 
}

//-----------------------------------------------------------------------------

void Police::EcritDroite (int x, int y, const std::string &txt)
{ 
  Acces().set_alignment (origin_top_right);
  Acces().draw(x,y,txt); 
}

//-----------------------------------------------------------------------------

void Police::EcritCentre (int txt_x, int txt_y, const std::string &txt)
{ 
#if PORT_CL07_OLD
  int x = txt_x;
  int y = txt_y;

  uint nbr_retour_ligne = occurence_caractere(txt,'\n');
  uint haut_ligne=Acces().get_height();
  const uint espace=1;
  y -= ( nbr_retour_ligne*(haut_ligne + espace) ) / 2;

  Acces().print_center (x,y,txt);
#else
  Acces().set_alignment (origin_top_center);
  Acces().draw(txt_x,txt_y,txt); 
#endif
}

//-----------------------------------------------------------------------------

CL_Font &Police::Acces() 
{ assert (m_police != NULL); return *m_police; }

//-----------------------------------------------------------------------------

const CL_Font &Police::Lit() const 
{ assert (m_police != NULL); return *m_police; }

//-----------------------------------------------------------------------------


uint Police::Larg (const std::string &txt)
{ 
#if PORT_CL07_OLD
  uint larg=0;
  long pos = txt.find ('\n', 0);
  if (0 <= pos) {
    long sauve_pos = pos;
    larg = Acces().get_text_width(txt.substr(0,pos)); 

    pos = txt.find ('\n', pos+1);
    uint nv_larg;
    while (0 <= pos)
    {
      nv_larg = Acces().get_text_width(txt.substr(sauve_pos, pos-sauve_pos));
      if (larg < nv_larg) larg = nv_larg;
      sauve_pos = pos;
      pos = txt.find ('\n', pos+1);
    }

    if (sauve_pos != (long)txt.length()-1) {
      nv_larg = Acces().get_text_width(txt.substr(sauve_pos));
      if (larg < nv_larg) larg = nv_larg;
    }
  } else {
    larg = Acces().get_text_width(txt); 
  }
  return larg;
#else
  return Acces().get_width(txt);
#endif
}

//-----------------------------------------------------------------------------

uint Police::Haut (const std::string &txt)
{ 
#if PORT_CL07_OLD
  uint nbr_retour_ligne = occurence_caractere(txt,'\n');
  uint haut_ligne=Acces().get_height();
  const uint espace=1;
  return haut_ligne +nbr_retour_ligne*(haut_ligne + espace);
#else
  return Acces().get_height(txt);
#endif
}

//-----------------------------------------------------------------------------
