/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Classe de gestion d'une image.
 *****************************************************************************/

#ifndef IMAGE_H
#define IMAGE_H
//-----------------------------------------------------------------------------
#include "../include/base.h"
#include <ClanLib/display.h>
//-----------------------------------------------------------------------------

class Image
{
protected:
  // Les donnes de l'image
  CL_Sprite *m_surface;

  // Frame de l'image (vaut toujours 0 pour une image fixe)
  uint m_frame;

public:
  Image ();
  virtual ~Image ();

  // Initialisation
  void Init (CL_Sprite *surface);

  // Draw le sprite
  void Draw(int x, int y) const; // need to be reimplemented in Sprite cause of direction
  void DrawFrame (int x, int y, uint frame) const;
  void DrawScaled (int x, int y, float echelle_x, float echelle_y) const;
  void DrawSize (int x, int y, uint larg, uint haut) const;

  // Accs  la surface
  CL_Surface LitSurface() const;
  const CL_Sprite& LitSprite() const;
  CL_Sprite& AccesSprite();

  // Change de frame
  void ChangeFrame(uint frame);
  uint LitFrame() const;

  // Passe  la frame suivant (revient  la premire si ncessaire)
  virtual void FrameSuivante();

  // Lit le nombre de frame
  uint LitNbrFrame() const;

  // Informations sur l'image
  uint GetWidth() const;
  uint GetHeight() const;
};

//-----------------------------------------------------------------------------
#endif
