/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Refresh d'un sprite : image ayant une direction (droite ou gauche),
 * et pouvant contenir plusieurs frames.
 *****************************************************************************/

#include "sprite.h"
//-----------------------------------------------------------------------------
#include "rotation.h"
#include <ClanLib/core.h>
//-----------------------------------------------------------------------------

Sprite::Sprite ()
  : Image()
{
  m_direction = 0;
}

//-----------------------------------------------------------------------------

void Sprite::Init (CL_Sprite *surface, bool autorise_rotation)
{
  Image::Init (surface);

  m_direction = 0;
  if (autorise_rotation) m_direction = 1;
}

//-----------------------------------------------------------------------------

void Sprite::ChangeDirection (int direction)
{
  if (m_direction == 0) return;
  m_direction = direction;
  if (m_direction == 1) {
    AccesSprite().set_scale(1,1);
  }
  else {
    AccesSprite().set_scale(-1,1);
  }
  
}

//-----------------------------------------------------------------------------

int Sprite::GetDirection() const { return m_direction; }

//-----------------------------------------------------------------------------

void Sprite::Draw(int x, int y) const
{ 
  int nv_x = x;
  if (m_direction == -1)
    nv_x +=  GetWidth();
  
  const_cast<Sprite*> (this) -> AccesSprite().draw (nv_x, y);
}
