/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Refresh d'un sprite : image ayant une direction (droite ou gauche),
 * et pouvant contenir plusieurs frames.
 *****************************************************************************/

#ifndef SPRITE_H
#define SPRITE_H
//-----------------------------------------------------------------------------
#include "../include/base.h"
#include "image.h"
//-----------------------------------------------------------------------------

class Sprite : public Image
{
protected:
  int m_direction; // 0 = pas de direction

public:
  Sprite ();

  // Initialisation
  void Init (CL_Sprite *surface, bool autorise_rotation=false);

  // Display the sprite (take care of direction)
  void Draw(int x, int y) const;

  // Direction (droite/gauche => 1/-1)
  // 0 si la direction n'est pas utilise
  void ChangeDirection (int direction);
  int GetDirection() const;
};

//-----------------------------------------------------------------------------
#endif
