/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Messages s'affichant en haut de l'ecran (et crit dans la console).
 *****************************************************************************/

#ifndef GAME_MESSAGES_H
#define GAME_MESSAGES_H
//-----------------------------------------------------------------------------
#include "../include/base.h"
#include <string>
#include <list>
//-----------------------------------------------------------------------------

class MessagesJeu
{
public:
  typedef struct message_t
  {
    std::string texte;
    uint temps;
    message_t (const std::string &a, uint b) { texte = a; temps = b; }
  } message_t;
  std::list<message_t> liste;
  typedef std::list<message_t>::iterator iterator;

public:
  // Remise a zro
  void Reset();

  // Affiche tous les messages
  void Affiche();

  // Actualisation : Supprime les anciens messages
  void Actualise();

  // Ajoute un message
  // [titre] message
  void Ajoute (const std::string &message);
};

extern MessagesJeu messages_jeu;

//-----------------------------------------------------------------------------
#endif
