/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Interface affichant diffrentes informations sur la jeu.
 *****************************************************************************/

#ifndef WEAPON_MENU_H
#define WEAPON_MENU_H
//-----------------------------------------------------------------------------
#include "../include/base.h"
#include "../team/character.h"
#include "../team/team.h"
#include "../graphic/image.h"
#include "../weapon/weapon.h"
#include <vector>
//-----------------------------------------------------------------------------

class ItemMenuArme{
public:
  int x, y, scale;
  Arme * arme;
  uint tps_debut_zoom;
  uint weapon_type;
private:
  bool zoom,dezoom;

public:
  ItemMenuArme(uint num_sort);
  void Reset();

  void Draw();
  void ChangeZoom();

  bool SourisDessus(int s_x, int s_y);

private:
  void InitZoom();
  void InitDezoom();
  void CalculeScale();
};

class MenuArmes
{
public:

private:
  std::vector<ItemMenuArme> boutons;
  typedef std::vector<ItemMenuArme>::iterator iterator;
  typedef std::vector<ItemMenuArme>::const_iterator const_iterator;
  Image image;

  bool affiche;
  bool montre; //vrai -> pendant l'anaimation pour montrer le menu
  bool cache; //vrai -> pendant l'anaimation pour cacher le menu

  uint tps_debut_mvt;

  uint nbr_weapon_type; //nombre de type d'arme = nbr de colonnes
  uint max_weapon;  //nombre max d'arme dans les differents type = nbr de lignes

public:
  MenuArmes();

  // Renvoie true si un bouton a t cliqu
  bool ActionClic (int x, int y);

  void Draw();
  void Init();

  int GetX() const;
  int GetY() const;
  int GetWidth() const;
  int GetHeight() const;

  void NewItem(Arme * new_item, uint num_sort);
  void ChangeAffichage();

  void ReactionSouris(int x,int y);

private:
  void CalculateSize();
  void Montre();
  void Cache();
  void DrawBouton(iterator bouton);
  void MouvementMontre(int nbr_bouton,int numero_bouton,iterator it, int colonne);
  bool MouvementCache(int nbr_bouton,int numero_bouton,iterator it,int colonne);
};

//-----------------------------------------------------------------------------
#endif
