/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 *  Refresh du vent
 *****************************************************************************/

#ifndef VENT_H
#define VENT_H
//-----------------------------------------------------------------------------
#include "../object/physical_obj.h"
#include "../tool/xml_document.h"
#include "../game/config.h"
#include "../gui/progress_bar.h"
//-----------------------------------------------------------------------------
namespace Wormux {
//-----------------------------------------------------------------------------

struct WindSprite
{
  double x,y;
  double mass; //Calculated (XML mass + Random mass)
  uint frame;
};

class Vent
{
private:
  BarreProg barre;
  long m_val,m_nv_val;
  uint m_last_move;

  CL_Sprite* m_wind_sprite;
  uint m_last_part_mvt,m_last_part_anim;
  WindSprite* particle;
  uint nbr_sprite,sprite_mvt_speed,sprite_anim_speed;
  int mass; //Mean of the mass(read in the XML file)

public:
  Vent();
  ~Vent();
  double LitVal() const;
  void ChangeVal();
  void Init();
  void Reset();
  void Draw();
  void DrawParticles();
  void LoadXML(xmlpp::Element *xml);
  void LoadXML_Sprite(CL_ResourceManager* res);
};


extern Vent vent;

//-----------------------------------------------------------------------------
} // namespace Wormux
//-----------------------------------------------------------------------------
#endif //VENT_H
