/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Arme pistolet : la balle part tout droit dans la direction donne par
 * le viseur. Si la balle ne touche pas un ver, elle va faire un trou dans
 * le terrain. La balle peut galement toucher les objets du plateau du jeu.
 *****************************************************************************/

#ifndef PISTOLET_H
#define PISTOLET_H
//-----------------------------------------------------------------------------
#include "../include/base.h"
#include "../graphic/image.h"
#include "weapon.h"
#include <ClanLib/display.h>
#include <vector>
//-----------------------------------------------------------------------------
namespace Wormux {
//-----------------------------------------------------------------------------

class BallePistolet : public ProjectileArme
{
private:
  double angle;
public:
  BallePistolet();
  void Tire();
  double LitAngle() const { return angle; }
  void Reset();
  void Init();
protected:
  void SignalCollision();
};

//-----------------------------------------------------------------------------

class Pistolet : public Arme
{
public:
  BallePistolet balle;

private:
  uint temps_capture;
  std::vector<CL_Point> lst_points;
  CL_Surface impact;    // Image (alpha) de l'impact

public:
  Pistolet();
  void Reset();
  void Init();
  void Draw();
  bool Tire ();
  void Refresh();
  WeaponConfig& cfg();
};

extern Pistolet pistolet;
//-----------------------------------------------------------------------------
} // namespace Wormux
#endif
