/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Skip his turn
 *****************************************************************************/

#include "../weapon/skip_turn.h"
//-----------------------------------------------------------------------------
#include "../graphic/graphism.h"
#include "../tool/i18n.h"
#include "../team/teams_list.h"
#include "../sound/jukebox.h"
#include "../game/game.h"
#include "../game/game_loop.h"
#include "../interface/game_msg.h"
//-----------------------------------------------------------------------------
namespace Wormux 
{
SkipTurn skipturn;
//-----------------------------------------------------------------------------

// Espace entre l'espace en l'image
const uint ESPACE = 5;

//-----------------------------------------------------------------------------

SkipTurn::SkipTurn() : Arme("skip_turn")
{}

//-----------------------------------------------------------------------------

void SkipTurn::Reset()
{
}

//-----------------------------------------------------------------------------

void SkipTurn::Init()
{
  m_name = _("Skip turn");
  icone = CL_Surface("skipturn_icon", &graphisme.weapons);
  m_image = CL_Surface("skipturn", &graphisme.weapons);
}

//-----------------------------------------------------------------------------

bool SkipTurn::Tire()
{ 
  
  // Informe que l'quipe passe son tour
  messages_jeu.Ajoute (Format(_("%s team has skipped its turn."), 
			      ActiveTeam().LitNom().c_str()));
  jukebox.PlayProfile(ActiveTeam().LitProfileSon(), "skip_turn");

  // Fin du tour
  jeu.autorise_action = false;
  boucle_jeu.ChangeEtat (jeuPAUSE_FIN_TOUR);
  return true;
}

//-----------------------------------------------------------------------------

void SkipTurn::Refresh()
{
}

//-----------------------------------------------------------------------------
} // namespace Wormux
