/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Suicide.
 *****************************************************************************/

#include "../weapon/suicide.h"
//-----------------------------------------------------------------------------
#include "../graphic/graphism.h"
#include "../tool/i18n.h"
#include "../team/teams_list.h"
#include "../sound/jukebox.h"
#include "../game/game.h"
#include "../game/game_loop.h"
//-----------------------------------------------------------------------------
namespace Wormux 
{
Suicide suicide;
//-----------------------------------------------------------------------------

// Espace entre l'espace en l'image
const uint ESPACE = 5;

//-----------------------------------------------------------------------------

Suicide::Suicide() : Arme("suicide")
{
  extra_params = new ExplosiveWeaponConfig();
}

//-----------------------------------------------------------------------------

void Suicide::Reset()
{
  anim_lance = false;
}

//-----------------------------------------------------------------------------

void Suicide::Init()
{
  m_name = _("Commit suicide");
  m_image = CL_Surface("suicide", &graphisme.weapons);
  hole_image = CL_Surface("suicide_hole", &graphisme.weapons);
  icone = CL_Surface("suicide_icon", &graphisme.weapons);
}

//-----------------------------------------------------------------------------

bool Suicide::Tire()
{ 
  anim_lance = true;
  jukebox.Play ("weapon/suicide", false, &son);
  jeu.autorise_action = false;
  boucle_jeu.ChangeEtat (jeuANIMATION);

  if(son==NULL)
  {
    anim_lance = false;
    m_is_active = false;
    ActiveCharacter().Die();
  }
  return true;
}

//-----------------------------------------------------------------------------

void Suicide::Refresh()
{
  if (!anim_lance) return;
  m_is_active = son -> is_playing();
  if (!m_is_active) 
  {
    ActiveCharacter().Die();
    anim_lance = false;
  }
}

//-----------------------------------------------------------------------------

ExplosiveWeaponConfig& Suicide::cfg()
{ return static_cast<ExplosiveWeaponConfig&>(*extra_params); }

//-----------------------------------------------------------------------------
} // namespace Wormux
