/******************************************************************************
 *  Wormux, a free clone of the game Worms from Team17.
 *  Copyright (C) 2001-2004 Lawrence Azzoug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 ******************************************************************************
 * Refresh des armes.
 *****************************************************************************/

#ifndef ARMES_H
#define ARMES_H
//-----------------------------------------------------------------------------
#include "../include/base.h"
#include "weapon.h"

#include <list>
#include <map>
//-----------------------------------------------------------------------------

// Classe de gestion des armes
class RefreshArmes
{
 private:
  std::list<Arme *> m_weapons_list;

  // The int is used to classify weapon by sort
  std::multimap<uint, Arme*> m_weapons_map;
  typedef std::multimap<uint, Arme*>::value_type keybind;
  void InitAndAddToList(Arme* arme, uint num_sort);

 public:
  RefreshArmes();

  void Init();

  // Refresh des armes
  // Retourne true si c'est la fin d'un tour
  void Refresh();

  // Return a list of  weapons
  std::list<Arme *>& GetList() ;

  Arme * GetWeaponBySort(uint num_sort);
  
};

extern RefreshArmes gst_armes;

//-----------------------------------------------------------------------------
#endif
